/*

* XBP_GUIDIALOG.PRG

* // ( 26.05.2011 )

*  COBA Systems Software
* BAST Open Source Project
* Business Account Software Technology
* www.cobasystems.com

*/


/*

Xbase++ code

Jedan GUI dialog se moe startovati bezboroj puta u bezbroj instanci.
Ovde je dat primer pisanja GUI dialoga koji se ne moe startovati
dva puta jer se proverava preko njegovog windows hendlera da li je
ve startovan.

Koristi se kod aplikacija koje dozvoljavaju da se istovremeno
startuje vie GUI dialoga, odnosno daju mogunost starta jednog
istog GUI dialoga vie puta (u vie instanci)

*/


#include "common.ch"
#include "appevent.ch"
#include "xbp.ch"
#include "font.ch"
#include "gra.ch"
#include "xbtsys.ch"

#include "dctree.ch"
#include "dcdialog.ch"

  MEMVAR appObject

 #pragma Library( "XppUi2.lib" )
 #pragma Library( "ADAC20b.LIB" )




******************************************************************
* Create std dialog window
******************************************************************
FUNCTION GuiStdDialog1( cTitle )

// ## KONTROLA INSTANCE PROZORA
  STATIC hWND1 := 0
// ## KONTROLA INSTANCE PROZORA

   LOCAL nEvent, mp1, mp2, radno, lExit1 := .F.
   LOCAL But0, But1, But2, But4, But5, But6, But7

   PUBLIC oDlg1

   PUBLIC But3, But77, but8

   DEFAULT cTitle TO "COBA"

  cWinTitle := UPPER(ALLTRIM(cTitle))


// ## KONTROLA INSTANCE PROZORA

// DA LI JE OVAJ PROZOR VE OTVOREN, PA AKO JESTE NE OTVARAJ GA PONOVO
// NEGO SAMO AKTIVIRAJ PROZOR SA TOFRONT I PREBACI FOKUS NA NJEGA:

 * IF WIN_START(cWinTitle) == .F.  // __WIN_START.PRG
 *  RETURN NIL                     // ovaj program ne radi
 * ENDIF                           // kad je prozor PARENT oPanel2 ???

  * MsgBox(var2char(hWND1),"1")
   IF hWND1 > 0                    // Probati ovde sa direktnom kontrolom
       oDlg1:ToFront()             // postojanja hWND1 otvorenog prozora
       SetAppFocus(tas01)          // preko DLL i windows API-ja
      RETURN NIL
   ENDIF
// ## KONTROLA INSTANCE PROZORA


   aPos1  := {0,0}
   aSize1 := oPanel2:CurrentSize()  // ovom prozoru roditelj (Parent) je oPanel2 ---------> VANO

   aPos  := {2,4} ; x := aSize1[1]-6; y := aSize1[2]-20
   aSize := {x,y}


   oDlg1          := XbpDialog():new(oPanel2,,aPos, aSize,, .F. )                 // varijanta 1 (explode)
 * oDlg1          := XbpDialog():new(oPanel2,SetAppWindow(),aPos1, aSize1,, .F. ) // varijanta 2

   oDlg1:icon     := NIL
   oDlg1:taskList := .T.
   oDlg1:TitleBar := .T.
   oDlg1:border   := XBPDLG_NO_BORDER
   oDlg1:SysMenu   := .F.
   oDlg1:title    := cWinTitle
   oDlg1:create()

      *drawingArea := oDlg1:drawingArea
      *drawingArea:SetColorBG(220,240,150)
      *drawingArea:SetFontCompoundName("10.Courier")


*   oDlg1:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_ESC , ;
*                        PostAppEvent( xbeP_Close,,, obj ), NIL ) }

    oDlg1:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_ESC , ;
                                    lExit1 := .T., NIL ) }


 duz := 60; sir := 24
 kol := 8; red1 := 4 ; red2 := 32

   PUBLIC tas01 // zbog prikaza red/kolona iz funkcije vieg nivoa: Marked_RowCol()

   tas01              := XbpPushbutton():new( oDlg1:drawingArea ,,{8,8}, {duz,sir} )
   tas01:caption      := "Kraj 1"
   tas01:clipSiblings := .T.
// ## KONTROLA INSTANCE PROZORA
   tas01:activate     := {|| hWND1 := 0, KRAJ1() } // {|| lExit1 := .T. } // {|| PostAppEvent( xbeP_Close,,, oDlg ) }
// ## KONTROLA INSTANCE PROZORA
   tas01:create()



   txt01              := XbpStatic():new( oDlg1:drawingArea ,,{8,100}, {400,200} )
   txt01:caption      := TEKST1()
   txt01:type         := XBPSTATIC_TYPE_TEXT
   txt01:options      := XBPSTATIC_TEXT_LEFT  + XBPSTATIC_TEXT_WORDBREAK
   txt01:create()
   txt01:SetFontCompoundName("8.Helv")

   // # kada se Jednog momenta radi samo sa jednim prozorom:
   // # iskljui/ukljui mogunost upotrebe Tree i dugmeta za kraj
      * oTree:disable(); oKraj:disable()
      * oTree:enable() ; oKraj:enable()

   oDlg1:show()
   oDlg1:setframestate(XBPDLG_FRAMESTAT_MAXIMIZED)


   oFocus := SetAppFocus( tas01 )

// ## KONTROLA INSTANCE PROZORA
   hWND1 := oDlg1:getHWND()
// ## KONTROLA INSTANCE PROZORA

   tone(1000)
   nEvent := xbe_None
   * WHILE nEvent <> xbeP_Close
   WHILE lExit1 <> .T.
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeM_RbDown
         *  bbb :=  oMenu:popUp( @oXbp, @mp1 )
      ENDIF
      IF nEvent == xbeP_Quit
         QUIT
      ENDIF
   ENDDO

   KRAJ1()

RETURN

******************************************************************
FUNCTION KRAJ1()
******************************************************************


  oDlg1:setframestate(XBPDLG_FRAMESTAT_MINIMIZED)
  oDlg1:destroy()
  oPanel2:hide()
  oPanel2:show()

   // # kada se Jednog momenta radi samo sa jednim prozorom:
   // # iskljui/ukljui mogunost upotrebe Tree i dugmeta za kraj
      * oTree:disable(); oKraj:disable()
      * oTree:enable() ; oKraj:enable()

  SetAppFocus(oTree)

RETURN NIL




******************************************************************
* Create std dialog window
******************************************************************
FUNCTION GuiStdDialog2( cTitle )

STATIC hWND2 := 0

   LOCAL nEvent, mp1, mp2, radno, lExit2 := .F.
   LOCAL But0, But1, But2, But4, But5, But6, But7

   PUBLIC oDlg2

   PUBLIC But3, But77, but8


   DEFAULT cTitle TO "COBA"

  cWinTitle := UPPER(ALLTRIM(cTitle))

   * MsgBox(var2char(hWND2),"2")
   IF hWND2 > 0
       oDlg2:ToFront()
       SetAppFocus(tas02)
      RETURN NIL
   ENDIF



   aPos1  := {0,0}
   aSize1 := oPanel2:CurrentSize()  // ovom prozoru roditelj (Parent) je oPanel2 ---------> VANO

   aPos  := {2,4} ; x := aSize1[1]-6; y := aSize1[2]-20
   aSize := {x,y}


   oDlg2          := XbpDialog():new(oPanel2,,aPos, aSize,, .F. )                 // varijanta 1 (explode)
 * oDlg2          := XbpDialog():new(oPanel2,SetAppWindow(),aPos1, aSize1,, .F. ) // varijanta 2

   oDlg2:icon     := NIL
   oDlg2:taskList := .T.
   oDlg2:TitleBar := .T.
   oDlg2:border   := XBPDLG_NO_BORDER
   oDlg2:SysMenu   := .F.
   oDlg2:title    := cWinTitle
   oDlg2:create()

*   oDlg2:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_ESC , ;
*                        PostAppEvent( xbeP_Close,,, obj ), NIL ) }

    oDlg2:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_ESC , ;
                                    lExit2 := .T., NIL ) }


 duz := 60; sir := 24
 kol := 8; red1 := 4 ; red2 := 32

   PUBLIC tas02 // zbog prikaza red/kolona iz funkcije vieg nivoa: Marked_RowCol()

   tas02              := XbpPushbutton():new( oDlg2:drawingArea ,,{8,8}, {duz,sir} )
   tas02:caption      := "Kraj 2"
   tas02:clipSiblings := .T.
   tas02:activate     := {|| hWND2 := 0, KRAJ2() } // {|| PostAppEvent( xbeP_Close,,, oDlg ) }
   tas02:create()

   // # kada se Jednog momenta radi samo sa jednim prozorom:
   // # iskljui/ukljui mogunost upotrebe Tree i dugmeta za kraj
      * oTree:disable(); oKraj:disable()
      * oTree:enable() ; oKraj:enable()

   oDlg2:show()
   oDlg2:setframestate(XBPDLG_FRAMESTAT_MAXIMIZED)

   oFocus := SetAppFocus( tas02 )

   hWND2 := oDlg2:getHWND()

   tone(1000)
   nEvent := xbe_None
   * WHILE nEvent <> xbeP_Close
   WHILE lExit2 <> .T.
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeM_RbDown
         *  bbb :=  oMenu:popUp( @oXbp, @mp1 )
      ENDIF
      IF nEvent == xbeP_Quit
         QUIT
      ENDIF
   ENDDO

   KRAJ2()

RETURN

******************************************************************
FUNCTION KRAJ2()
******************************************************************


  oDlg2:setframestate(XBPDLG_FRAMESTAT_MINIMIZED)
  oDlg2:destroy()
  oPanel2:hide()
  oPanel2:show()

   // # kada se Jednog momenta radi samo sa jednim prozorom:
   // # iskljui/ukljui mogunost upotrebe Tree i dugmeta za kraj
      * oTree:disable(); oKraj:disable()
      * oTree:enable() ; oKraj:enable()

    SetAppFocus(oTree)

RETURN NIL




******************************************************************
* Create std dialog window
******************************************************************
FUNCTION GuiStdDialog3( cTitle )

STATIC hWND3 := 0

   LOCAL nEvent, mp1, mp2, radno, lExit3 := .F.
   LOCAL But0, But1, But2, But4, But5, But6, But7

   PUBLIC oDlg3

   PUBLIC But3, But77, but8


   DEFAULT cTitle TO "COBA"

  cWinTitle := UPPER(ALLTRIM(cTitle))

   * MsgBox(var2char(hWND3),"3")
   IF hWND3 > 0
       oDlg3:ToFront()
       SetAppFocus(tas03)
      RETURN NIL
   ENDIF



   aPos1  := {0,0}
   aSize1 := oPanel2:CurrentSize()  // ovom prozoru roditelj (Parent) je oPanel2 ---------> VANO

   aPos  := {2,4} ; x := aSize1[1]-6; y := aSize1[2]-20
   aSize := {x,y}


   oDlg3          := XbpDialog():new(oPanel2,,aPos, aSize,, .F. )                 // varijanta 1 (explode)
 * oDlg3          := XbpDialog():new(oPanel2,SetAppWindow(),aPos1, aSize1,, .F. ) // varijanta 2

   oDlg3:icon     := NIL
   oDlg3:taskList := .T.
   oDlg3:TitleBar := .T.
   oDlg3:border   := XBPDLG_NO_BORDER
   oDlg3:SysMenu   := .F.
   oDlg3:title    := cWinTitle
   oDlg3:create()

*   oDlg3:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_ESC , ;
*                        PostAppEvent( xbeP_Close,,, obj ), NIL ) }

    oDlg3:keyboard    := {|nKey,x,obj| IIf( nKey == xbeK_ESC , ;
                                    lExit3 := .T., NIL ) }


 duz := 60; sir := 24
 kol := 8; red1 := 4 ; red2 := 32

   PUBLIC tas03 // zbog prikaza red/kolona iz funkcije vieg nivoa: Marked_RowCol()

   tas03              := XbpPushbutton():new( oDlg3:drawingArea ,,{8,8}, {duz,sir} )
   tas03:caption      := "Kraj 3"
   tas03:clipSiblings := .T.
   tas03:activate     := {|| hWND3 := 0, KRAJ3() } // {|| PostAppEvent( xbeP_Close,,, oDlg ) }
   tas03:create()

   // # kada se Jednog momenta radi samo sa jednim prozorom:
   // # iskljui/ukljui mogunost upotrebe Tree i dugmeta za kraj
      * oTree:disable(); oKraj:disable()
      * oTree:enable() ; oKraj:enable()

   oDlg3:show()
   oDlg3:setframestate(XBPDLG_FRAMESTAT_MAXIMIZED)

   oFocus := SetAppFocus( tas03 )

   hWND3 := oDlg3:getHWND()

   tone(1000)
   nEvent := xbe_None
   * WHILE nEvent <> xbeP_Close
   WHILE lExit3 <> .T.
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeM_RbDown
         *  bbb :=  oMenu:popUp( @oXbp, @mp1 )
      ENDIF
      IF nEvent == xbeP_Quit
         QUIT
      ENDIF
   ENDDO

   KRAJ3()

RETURN

******************************************************************
FUNCTION KRAJ3()
******************************************************************


  oDlg3:setframestate(XBPDLG_FRAMESTAT_MINIMIZED)
  oDlg3:destroy()
  oPanel2:hide()
  oPanel2:show()

   // # kada se Jednog momenta radi samo sa jednim prozorom:
   // # iskljui/ukljui mogunost upotrebe Tree i dugmeta za kraj
      * oTree:disable(); oKraj:disable()
      * oTree:enable() ; oKraj:enable()

  SetAppFocus(oTree)

RETURN NIL







FUNCTION TEKST1()
LOCAL ch := chr(13)+chr(10)
ctxt := ;
"Alaska Xbase++ code"+ch+;
"MULTIPLI DIALOZI Zaposleni, Porezi, Doprinosi"+ch+;
" "+ch+;
"Jedan GUI dialog se moe startovati bezboroj puta u bezbroj instanci. "+;
"Ovde je dat primer pisanja GUI dialoga koji se ne moe startovati "+;
"dva puta jer se proverava preko njegovog windows hendlera da li je "+;
"ve startovan. "+ch+;
" "+ch+;
"Koristi se kod aplikacija koje dozvoljavaju da se istovremeno "+;
"startuje vie GUI dialoga, odnosno daju mogunost starta jednog "+;
"istog GUI dialoga vie puta (u vie instanci) "+ch+;
" "+ch+;
"Ovde se mogu istovremeno startovati tri dialoga: dialog Zaposleni, "+;
"dialog Porezi i dialog Doprinosi, i moe se naizmenino raditi sa "+;
"svakim od njih. Ali Jedan isti dialog se ne moe dva puta startovati."

RETURN cTxt
